d=3; % space dimension
N=3; % or N=[3,3,3]
Oh=OrthMesh(d,N,'type','orthotope'); 

m=3; % maximun number of subdivision
nme=Oh.Mesh.nme; % Number of Mesh elements
ndiscells=randi([1,m],1,nme);

sc01=fc_hypermesh.refinement.refine(Oh,ndiscells);
figure(1)
fc_hypermesh.refinement.plotsubcells(sc01)
view(3)
axis image
set(legend(),'Location','eastoutside')
xlabel('x'),ylabel('y'),zlabel('z')
title(sprintf('Cells [%d %d %d]: subdivisions with orthotopes',N,N,N))

types=ones(1,nme);
sc02=fc_hypermesh.refinement.refine(Oh,ndiscells,types);
figure(2)
fc_hypermesh.refinement.plotsubcells(sc02)
view(3)
axis image
set(legend(),'Location','eastoutside')
xlabel('x'),ylabel('y'),zlabel('z')
title(sprintf('Cells [%d %d %d]: subdivisions with orthotopes',N,N,N))

sc03=fc_hypermesh.refinement.refine(Oh,ndiscells,'simplicial');
figure(3)
fc_hypermesh.refinement.plotsubcells(sc03)
view(3)
axis image
set(legend(),'Location','eastoutside')
xlabel('x'),ylabel('y'),zlabel('z')
title(sprintf('Cells [%d %d %d]: subdivisions with simplices',N,N,N))

types=zeros(1,nme);
sc04=fc_hypermesh.refinement.refine(Oh,ndiscells,types);
figure(4)
fc_hypermesh.refinement.plotsubcells(sc03)
view(3)
axis image
set(legend(),'Location','eastoutside')
xlabel('x'),ylabel('y'),zlabel('z')
title(sprintf('Cells [%d %d %d]: subdivisions with simplices',N,N,N))

fc_tools.graphics.DisplayFigures()

